com.dlsc.flexgantt.swing.layer

## Class LayerContainerRowHeader

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - javax.swing.JComponent
      - - javax.swing.JPanel
        - - com.dlsc.flexgantt.swing.GanttChartControl
          - - com.dlsc.flexgantt.swing.AbstractRowHeader<ILayerContainerRowHeaderRenderer>
            - - com.dlsc.flexgantt.swing.layer.LayerContainerRowHeader

- All Implemented Interfaces:
    ICommandStackListener, ITreeTableModelListener, MouseListener, MouseMotionListener, ImageObserver, MenuContainer, PropertyChangeListener, Serializable, EventListener, Accessible, TreeExpansionListener, TreeModelListener, TreeSelectionListener
  Direct Known Subclasses:
    MacLayerContainerRowHeader

      public class LayerContainerRowHeader
      extends AbstractRowHeader<ILayerContainerRowHeaderRenderer>

  A row header component used on the left edge of the layer container. The row header can be used to visualize row specific information that is not supposed to move while the user scrolls horizontally. One example would be a capacity scale used for rows that show a resource node.

  The row header is invisible by default. It can be made visible by calling `JScrollPane.getRowHeader().setVisible(true)`.

  Since:
    1.0
  Version:
    $Revision: 1.8 $
  Author:
    Dirk Lemmermann
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class javax.swing.JPanel

      `JPanel.AccessibleJPanel`

    - ### Nested classes/interfaces inherited from class javax.swing.JComponent

      `JComponent.AccessibleJComponent`

    - ### Nested classes/interfaces inherited from class java.awt.Container

      `Container.AccessibleAWTContainer`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

  - ### Field Summary

    - ### Fields inherited from class javax.swing.JComponent

      `listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

    - ### Fields inherited from class java.awt.Component

      `accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `LayerContainerRowHeader(LayerContainer lc)` Constructs a new row header for the given layer container.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Point` | `getCursorLocation()` Returns the current cursor location.
    `LayerContainer` | `getLayerContainer()` Returns the parent layer container.
    `Dimension` | `getPreferredSize()`
    `void` | `mouseExited(MouseEvent e)`
    `void` | `mouseMoved(MouseEvent e)`
    `protected void` | `paintComponent(Graphics g)`
    `protected void` | `paintCursor(Graphics g, Point location)` Draws the cursor at the given location.
    `protected void` | `paintUnusedRow(Graphics g, int y, int width, int height, int row)` Draws additional visual feedback for unused rows.
    `void` | `propertyChange(PropertyChangeEvent evt)`

    - ### Methods inherited from class com.dlsc.flexgantt.swing.AbstractRowHeader

      `commandStackChanged, getGridColor, getMenuProvider, getRendererMap, getRowHeaderRenderer, getTreeTable, isFocused, isFocusEnabled, maybeShowPopup, mouseClicked, mouseDragged, mouseEntered, mousePressed, mouseReleased, paintUnusedRows, setFocusEnabled, setGridColor, setMenuProvider, setRendererMap, setRowHeaderRenderer, treeCollapsed, treeExpanded, treeNodeKeyChanged, treeNodesChanged, treeNodesInserted, treeNodesRemoved, treeNodeValueChanged, treeStructureChanged, valueChanged`

    - ### Methods inherited from class com.dlsc.flexgantt.swing.GanttChartControl

      `getGanttChart, print, printBorder`

    - ### Methods inherited from class javax.swing.JPanel

      `getAccessibleContext, getUI, getUIClassID, paramString, setUI, updateUI`

    - ### Methods inherited from class javax.swing.JComponent

      `addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintImmediately, paintImmediately, printAll, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### LayerContainerRowHeader

          public LayerContainerRowHeader(LayerContainer lc)

      Constructs a new row header for the given layer container.
      Parameters:
        `lc` - the parent layer container
      Since:
        1.0

  - ### Method Detail

    - #### getPreferredSize

          public Dimension getPreferredSize()

      Overrides:
        `getPreferredSize` in class `JComponent`

    - #### getLayerContainer

          public LayerContainer getLayerContainer()

      Returns the parent layer container.
      Returns:
        the parent layer container
      Since:
        1.0

    - #### paintComponent

          protected void paintComponent(Graphics g)

      Overrides:
        `paintComponent` in class `AbstractRowHeader<ILayerContainerRowHeaderRenderer>`

    - #### paintUnusedRow

          protected void paintUnusedRow(Graphics g,
                                        int y,
                                        int width,
                                        int height,
                                        int row)

      Description copied from class: `AbstractRowHeader`
      Draws additional visual feedback for unused rows. The default implementation of this method does nothing. Subclasses can choose to override this method to perform extra rendering operations. This method gets invoked by `AbstractRowHeader.paintUnusedRows(Graphics, Rectangle, int, int)`.
      Overrides:
        `paintUnusedRow` in class `AbstractRowHeader<ILayerContainerRowHeaderRenderer>`
      Parameters:
        `g` - the graphics context into which to draw
        `y` - the current drawing clip
        `width` - the width of the cell
        `height` - the height of the cell
        `row` - the row index

    - #### paintCursor

          protected void paintCursor(Graphics g,
                                     Point location)

      Draws the cursor at the given location.
      Parameters:
        `g` - the gaphics context into which to draw
        `location` - the location of the cursor
      Since:
        1.0

    - #### mouseMoved

          public void mouseMoved(MouseEvent e)

      Specified by:
        `mouseMoved` in interface `MouseMotionListener`
      Overrides:
        `mouseMoved` in class `AbstractRowHeader<ILayerContainerRowHeaderRenderer>`

    - #### mouseExited

          public void mouseExited(MouseEvent e)

      Specified by:
        `mouseExited` in interface `MouseListener`
      Overrides:
        `mouseExited` in class `AbstractRowHeader<ILayerContainerRowHeaderRenderer>`

    - #### getCursorLocation

          public Point getCursorLocation()

      Returns the current cursor location.
      Returns:
        the cursor location
      Since:
        1.0

    - #### propertyChange

          public void propertyChange(PropertyChangeEvent evt)

      Specified by:
        `propertyChange` in interface `PropertyChangeListener`
      Overrides:
        `propertyChange` in class `AbstractRowHeader<ILayerContainerRowHeaderRenderer>`

Copyright © 2006–2020 Dirk Lemmermann Software & Consulting. All rights reserved.